typedef struct _rwlock_t { sem_t writelock; sem_t lock; int readers;
                         } rwlock_t;
void rwlock_init(rwlock_t *L) {
    L->readers = 0;
    sem_init(&L->lock, 1); 
    sem_init(&L->writelock, 1); }
void rwlock_acquire_readlock(rwlock_t *L) {
    sem_wait(&L->lock);                       // ra1
    L->readers++;                             // ra2
    if (L->readers == 1)                      // ra3
	sem_wait(&L->writelock);              // ra4
    sem_post(&L->lock); }                     // ra5
void rwlock_release_readlock(rwlock_t *L) {
    sem_wait(&L->lock);                       // rr1
    L->readers--;                             // rr2
    if (L->readers == 0)                      // rr3
	sem_post(&L->writelock);              // rr4
    sem_post(&L->lock); }                     // rr5
void rwlock_acquire_writelock(rwlock_t *L) { sem_wait(&L->writelock);}
void rwlock_release_writelock(rwlock_t *L) { sem_post(&L->writelock);}

